//+------------------------------------------------------------------+
//|                                                    Vinin_TMA.mq4 |
//|                                            Copyright 2013, Vinin |
//|                                                    vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, Vinin"
#property link      "vinin@mail.ru"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_color2 Red
#property indicator_color3 Red
//--- input parameters
extern int    HalfLength      = 56;
extern int    Price           = PRICE_OPEN;
extern int    mode            = MODE_LWMA;
extern double ATRMultiplier   = 2.0;
extern int    ATRPeriod       = 100;
//--- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(4);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer4);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   int i, limit=Bars-counted_bars-1;
   for (i=limit;i>=0;i--) {
      ExtMapBuffer1[i]=iMA(NULL, 0, HalfLength, 0, mode, Price, i);
      double range = iATR(NULL,0,ATRPeriod,i+10)*ATRMultiplier;
      ExtMapBuffer2[i] = ExtMapBuffer1[i]+range;
      ExtMapBuffer3[i] = ExtMapBuffer1[i]-range;   
   }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+